<?php

namespace App\Http\Controllers\Admin;

use App\Module;
use Exception;
use App\Question;
use Illuminate\View\View;
use App\QuestionDescription;
use App\CityDescription;
use Illuminate\Http\Request;
use Illuminate\Http\JsonResponse;
use Illuminate\Routing\Redirector;
use App\Http\Controllers\Controller;
use App\Http\Requests\QuestionRequest;
use Illuminate\Http\RedirectResponse;
use Mcamara\LaravelLocalization\Facades\LaravelLocalization;

class QuestionController extends Controller
{

    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/questions';
    /** View folder */
    private $viewDirectory= 'admin.questions.';

    /**
     * Display a listing of the resource.
     *
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('questions.head');
        $request= $request->toArray();
        return view($this->viewDirectory.'index',compact('title'));
    }

    /**
     * return data of the pages.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $query = Question::latest()
            ->join('question_descriptions AS ad', 'questions.id', 'ad.question_id')
            ->join('languages', 'languages.id', 'ad.language_id')
            ->where('local', LaravelLocalization::getCurrentLocale())
            ->select(['ad.question', 'questions.*']);

        if ($request->date_from) {
            $query->whereDate('questions.created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('questions.created_at', '<=', $request->date_to);
        }

        if ($request->name) {
            $query->where('ad.name', 'LIKE', '%'.$request->name.'%');
        }
       

        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }

        $questions= $query->paginate(100);

        return view($this->viewDirectory.'grid',compact('questions'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('questions.store');
        $head= __('questions.new');
        return view( $this->viewDirectory.'form', compact('action', 'head') );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param QuestionRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(QuestionRequest $request) :RedirectResponse
    {
        $question = Question::create($request->all());

        
        $this->saveData($request, $question->id);

        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }


    /**
     * Show the form for editing the specified resource.
     *
     * @param Question $question
     * @return View
     */
    public function edit(Question $question) :View
    {
        $action= route('questions.update', $question->id);

        $query = QuestionDescription::where('question_id', $question->id)
            ->join('languages', 'languages.id', 'question_descriptions.language_id')
            ->select(['question_descriptions.*', 'languages.local']);

        $questionDescription= $query->get();

        foreach ($questionDescription as $row) {
            $question[$row->local]= $row;
        }

        return view( $this->viewDirectory.'form', compact('question', 'action') );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param QuestionRequest $request
     * @param Question $question
     * @return RedirectResponse|Redirector
     */
    public function update(QuestionRequest $request, Question $question) :RedirectResponse
    {

        // Update image and category id if request has it
        $question->update($request->all());

        // update image to youtube api thumbnail if request have not image
       

        // Delete old description
        QuestionDescription::where('question_id', $question->id)->delete();


        // Insert new description
        $this->saveData( $request, $question->id );

        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Handle Save form data
     *
     * @param QuestionRequest $request
     * @param int $question_id
     * @return void
     */

    private function saveData(QuestionRequest $request, int $question_id ):void
    {
        $requestData= $request->all();
        foreach (languages() as $lang) {
            $data=[
                'question_id'=> $question_id,
                'language_id'=> $lang->id,
                'answer'=> $requestData['answer_'.$lang->local],
                'question'=> $requestData['question_'.$lang->local],
                
            ];
            QuestionDescription::create($data);
        }

        

    }


    /**
     * Remove the specified resource from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $question = Question::withTrashed()->find($id);
        if ($question) {
            if ($question->deleted_at) {
                $question->forceDelete();
            } else {
                $question->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        if ($request->force) {
            Question::onlyTrashed()->whereIn('id', $ids)->forceDelete();
        } else {
            Question::whereIn('id', $ids)->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified category from storage
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $question = Question::withTrashed()->find($id);

        if ($question){
            $question->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);
    }

    /**
     * Restore several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $question = Question::whereIn('id', $request->ids)->onlyTrashed();
        if ($question){
            $question->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
    }
}
